/******************************************************************
 *	USART MW[
 ******************************************************************
 *	{[[gݒ (U2Xgp)
	static	void USART_init(uchar baud_h);
 *
 *	RS232CM^XN.
	static	void USART_RecvTask(void);
	static	void USART_SendTask(void);
 */


/******************************************************************
 *
 ******************************************************************
 */
//#define F_CPU 12000000      	/* MCUNbNg */
//#define BAUD 9600             	/* ړIUSART{[[gx */
//#define MYUBRR F_CPU/16/BAUD-1 	/* ړIUBRRl */


#ifndef TXBUF_SIZE			// Mobt@TCY
#error Define TXBUF_SIZE in Makefile
#endif
#ifndef RXBUF_SIZE			// MFIFOTCY.
#error Define RXBUF_SIZE in Makefile
#endif

uchar rsbuf[TXBUF_SIZE];// RS232CMobt@.
// REGISTER uchar rsptr ASM("r7");	 // on_ (0..3) A4 ̎͋.

uchar USART_rxbuf[RXBUF_SIZE];	// MFIFO.
//REGISTER uchar USART_rxptr ASM("r7");	// FIFOݒn_.

REGISTER uint8_t RxRp ASM("r8");	//Mf[^ǂݍ
REGISTER uint8_t RxWp ASM("r9");	//Mf[^

REGISTER uint8_t TxRp ASM("r10");	//Mf[^ǂݍ
REGISTER uint8_t TxWp ASM("r11");	//Mf[^

//#define	 USART_default_baud  19200,0


//	baud_rate ubrrɃZbglɕϊ.
void baud_calc(void);	 // asm.S

uchar USART_getc(void);
static void USART_putc(uchar);

/******************************************************************
 *	USART̏.
 ******************************************************************
 */
/******************************************************************
 *	{[[gݒ.
 *  : int baud_l  {[[g(16bit)         [15:0]
 *      uchar baud_h  {[[g( 8bit) [23:16]
 ******************************************************************
 */
static void USART_Init(void)
{
	uchar csrc=0x0e;	// 8N2

	baud_calc();
//	UBRRH = brr>>8; 		/* {[[gݒ(ʃoCg) */
//	UBRRL = brr;     	/* {[[gݒ(ʃoCg) */
	UCSRC = csrc;		/* t[`ݒ(8rbg,2Xgbv rbg) */
//	UCSRB = (1<<RXEN)|(1<<TXEN);      /* M */
	UCSRA = (1<<U2X);	// vXP[ 1/16  1/8 ɕύX.

//	rsptr = TXBUF_SIZE;

	RxRp = RxWp = 0;
	TxRp = TxWp = 0;
	UCSRB = (1<<RXEN)|(1<<TXEN) | (1<<RXCIE);      /* M & M݋*/
}

#if 0	//@@kuga 폜
/******************************************************************
 *	RS232CM^XN.
 ******************************************************************
 */
static void USART_RecvTask(void)
{
	while( UCSRA & (1<<RXC) ) {					// M? .
		uchar rxchr = UDR;    					// Mf[^擾.
		USART_rxbuf[USART_rxptr] = rxchr;		// FIFȌ݃|C^.
		// FIFOtȂA|C^XVȂ.
		if(	USART_rxptr < (RXBUF_SIZE-1)) {
			USART_rxptr++;
		}
	}
}

/******************************************************************
 *	RS232CM^XN.
 ******************************************************************
 */
static void USART_SendTask(void)
{
	if(	rsptr < TXBUF_SIZE ) {
		//Mobt@Ƀf[^cĂȂ,
		//
		//	1Ms.
		//
		if ( !(UCSRA & (1<<UDRE)) ) {
			return ;	/* 2:Mobt@󂫑ҋ@ */
		}
	    UDR = rsbuf[rsptr++];     			/* M */
	}else{
        if( usbAllRequestsAreDisabled() ) {
            usbEnableAllRequests();
        }
	}
	return ;			/* 0:Mobt@ */
}

#endif


static void USART_SendTask(void)
{
	if ( (TxWp!=TxRp) && (UCSRA & (1<<UDRE)) ) {
		UDR=rsbuf[TxRp++];
		TxRp &= (TXBUF_SIZE-1);
	   if( usbAllRequestsAreDisabled() ) {
			uchar used=(TxWp-TxRp) & (TXBUF_SIZE-1);
	 		if ( used<=(TXBUF_SIZE-HW_CDC_PACKET_SIZE-1) ) {		//Mɋ󂠂?
	            usbEnableAllRequests();
	        }
		}
	}
}


static void USART_putc(uchar data)
{
	rsbuf[TxWp]=data;
	TxWp++;
	TxWp &= (TXBUF_SIZE-1);
}


